/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>

static size_t debug_handle;
/* This must be defined before including debug.h */
#define MF_SOURCE_NAME  debug_handle

#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "other.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

static int
valid_user_p(eval_environ_t env, const char *name)
{
	int rc;
	struct mu_auth_data *auth_data = NULL;

	rc = mu_get_auth(&auth_data, mu_auth_key_name, name);
	mu_auth_data_free(auth_data);
	switch (rc) {
	case 0:
		rc = 1;
		break;
		
	case MU_ERR_AUTH_FAILURE:
		rc = 0;
		break;

	case EAGAIN:
                	env_throw_bi(env, mfe_temp_failure, NULL, _("temporary failure querying for username %s"),name);
#line 38
		break;

	default:
                	env_throw_bi(env, mfe_failure, NULL, _("failure querying for username %s"),name);
#line 44
		break;
	}

	debug2(10, "Checking user %s: %s", name,
	       rc ? "true" : "false");
	return rc;
}

void
#line 52
bi_validuser(eval_environ_t env)
#line 52

#line 52 "other.bi"
{
#line 52
	
#line 52

#line 52

#line 52
char * name;
#line 52
        
#line 52
get_string_arg(env, 0, &name);
#line 52
        
#line 52

#line 52
        adjust_stack(env, 1);
#line 52

#line 52
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 52
		prog_trace(env, "validuser %s",name);;
#line 52

{
	
#line 54
do {
#line 54
  push(env, (STKVAL) (valid_user_p(env, name)));
#line 54
  return;
#line 54
} while (0);
}
}

void
#line 58
bi_interval(eval_environ_t env)
#line 58

#line 58 "other.bi"
{
#line 58
	
#line 58

#line 58

#line 58
char * str;
#line 58
        
#line 58
get_string_arg(env, 0, &str);
#line 58
        
#line 58

#line 58
        adjust_stack(env, 1);
#line 58

#line 58
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 58
		prog_trace(env, "interval %s",str);;
#line 58

{
       time_t t;
       const char *endp;

       	if (!(parse_time_interval(str, &t, &endp) == 0))
#line 63
			env_throw_bi(env, mfe_invtime, "interval", _("unrecognized time format (near `%s')"),endp)
#line 65
;
       
#line 66
do {
#line 66
  push(env, (STKVAL) (t));
#line 66
  return;
#line 66
} while (0);
}
}

void
#line 70
bi_rate(eval_environ_t env)
#line 70

#line 70 "other.bi"
{
#line 70
	
#line 70

#line 70
long __bi_argcnt;
#line 70
char * key;
#line 70
        long  interval;
#line 70
        long  mincnt;
#line 70
        long  threshold;
#line 70
        
#line 70
get_string_arg(env, 1, &key);
#line 70
        get_numeric_arg(env, 2, &interval);
#line 70
        get_numeric_arg(env, 3, &mincnt);
#line 70
        get_numeric_arg(env, 4, &threshold);
#line 70
        
#line 70
get_numeric_arg(env, 0, &__bi_argcnt);
#line 70
        adjust_stack(env, __bi_argcnt + 1);
#line 70

#line 70
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 70
		prog_trace(env, "rate %s %lu %lu %lu",key, interval, ((__bi_argcnt > 2) ? mincnt : 0), ((__bi_argcnt > 3) ? threshold : 0));;

{
	long ret;

		if (!(get_rate(key, &ret, interval,
#line 75
			   ((__bi_argcnt > 2) ? mincnt : 0),
#line 75
			   ((__bi_argcnt > 3) ? threshold : 0)) == mf_success))
#line 75
			env_throw_bi(env, mfe_dbfailure, "rate", _("cannot get rate for %s"),key)
#line 79
;

	
#line 81
do {
#line 81
  push(env, (STKVAL) (ret));
#line 81
  return;
#line 81
} while (0);
}
}

void
#line 85
bi_tbf_rate(eval_environ_t env)
#line 85

#line 85 "other.bi"
{
#line 85
	
#line 85

#line 85

#line 85
char * key;
#line 85
        long  cost;
#line 85
        long  interval;
#line 85
        long  burst_size;
#line 85
        
#line 85
get_string_arg(env, 0, &key);
#line 85
        get_numeric_arg(env, 1, &cost);
#line 85
        get_numeric_arg(env, 2, &interval);
#line 85
        get_numeric_arg(env, 3, &burst_size);
#line 85
        
#line 85

#line 85
        adjust_stack(env, 4);
#line 85

#line 85
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 85
		prog_trace(env, "tbf_rate %s %lu %lu %lu",key, cost, interval, burst_size);;

{
        int result;
		
		if (!(check_tbf_rate(key, &result, cost, interval,
#line 90
				 burst_size) == mf_success))
#line 90
			env_throw_bi(env, mfe_dbfailure, "tbf_rate", _("cannot check TBF rate for %s"),key)
#line 93
;
	
	
#line 95
do {
#line 95
  push(env, (STKVAL) (result));
#line 95
  return;
#line 95
} while (0);
}
}

void
#line 99
bi_debug_level(eval_environ_t env)
#line 99

#line 99 "other.bi"
{
#line 99
	
#line 99

#line 99
long __bi_argcnt;
#line 99
char * modname;
#line 99
        
#line 99
get_string_arg(env, 1, &modname);
#line 99
        
#line 99
get_numeric_arg(env, 0, &__bi_argcnt);
#line 99
        adjust_stack(env, __bi_argcnt + 1);
#line 99

#line 99
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 99
		prog_trace(env, "debug_level %s",((__bi_argcnt > 0) ? modname : ""));;
#line 99

{
	int level;
		if (!(debug_module_level(((__bi_argcnt > 0) ? modname : NULL), &level) == 0))
#line 102
			env_throw_bi(env, mfe_range, "debug_level", _("invalid module name: %s"),modname)
#line 104
;
	
#line 105
do {
#line 105
  push(env, (STKVAL) (level));
#line 105
  return;
#line 105
} while (0);
}
}

void
#line 109
bi_debug_spec(eval_environ_t env)
#line 109

#line 109 "other.bi"
{
#line 109
	
#line 109

#line 109
long __bi_argcnt;
#line 109
char * modnames;
#line 109
        long  minlevel;
#line 109
        
#line 109
get_string_arg(env, 1, &modnames);
#line 109
        get_numeric_arg(env, 2, &minlevel);
#line 109
        
#line 109
get_numeric_arg(env, 0, &__bi_argcnt);
#line 109
        adjust_stack(env, __bi_argcnt + 1);
#line 109

#line 109
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 109
		prog_trace(env, "debug_spec %s %lu",((__bi_argcnt > 0) ? modnames : ""), ((__bi_argcnt > 1) ? minlevel : 0));;
#line 109

{
	char *buf;
	char *s;
	size_t off;

 	int rc = debug_spec_string(((__bi_argcnt > 0) ? modnames : NULL),
				   ((__bi_argcnt > 1) ? minlevel : 0),
				   &buf);
		if (!(rc == 0))
#line 118
			env_throw_bi(env, mfe_failure, "debug_spec", "%s",mu_strerror(rc))
#line 120
;
	s = (char*) env_data_ref(env, (off = heap_reserve(env, strlen(buf) + 1)));
	strcpy(s, buf);
	free(buf);
	
#line 124
do {
#line 124
  push(env, (STKVAL) (off));
#line 124
  return;
#line 124
} while (0);
}
}

void
#line 128
bi_debug(eval_environ_t env)
#line 128

#line 128 "other.bi"
{
#line 128
	
#line 128

#line 128

#line 128
char * spec;
#line 128
        
#line 128
get_string_arg(env, 0, &spec);
#line 128
        
#line 128

#line 128
        adjust_stack(env, 1);
#line 128

#line 128
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 128
		prog_trace(env, "debug %s",spec);;
#line 128

{
	debug_parse_spec(spec);
}
}

void
#line 134
bi_program_trace(eval_environ_t env)
#line 134

#line 134 "other.bi"
{
#line 134
	
#line 134

#line 134

#line 134
char * name;
#line 134
        
#line 134
get_string_arg(env, 0, &name);
#line 134
        
#line 134

#line 134
        adjust_stack(env, 1);
#line 134

#line 134
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 134
		prog_trace(env, "program_trace %s",name);;
#line 134

{
	enable_prog_trace(name);
}
}

void
#line 140
bi_cancel_program_trace(eval_environ_t env)
#line 140

#line 140 "other.bi"
{
#line 140
	
#line 140

#line 140

#line 140
char * name;
#line 140
        
#line 140
get_string_arg(env, 0, &name);
#line 140
        
#line 140

#line 140
        adjust_stack(env, 1);
#line 140

#line 140
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 140
		prog_trace(env, "cancel_program_trace %s",name);;
#line 140

{
	disable_prog_trace(name);
}
}	

void
#line 146
bi_stack_trace(eval_environ_t env)
#line 146

#line 146 "other.bi"
{
#line 146
	
#line 146

#line 146

#line 146

#line 146

#line 146

#line 146
        adjust_stack(env, 0);
#line 146

#line 146
	if (builtin_module_trace(BUILTIN_IDX_other))
#line 146
		prog_trace(env, "stack_trace");;
#line 146

{
	runtime_stack_trace(env);
}
}


#line 152
void
#line 152
other_init_builtin()
#line 152
{
#line 152
        debug_handle = debug_register("bi_other");
#line 152
	#line 52 "other.bi"
va_builtin_install_ex("validuser", bi_validuser, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 58 "other.bi"
va_builtin_install_ex("interval", bi_interval, 0, dtype_number, 1, 0, 0|0, dtype_string);
#line 70 "other.bi"
va_builtin_install_ex("rate", bi_rate, 0, dtype_number, 4, 2, 0|0, dtype_string, dtype_number, dtype_number, dtype_number);
#line 85 "other.bi"
va_builtin_install_ex("tbf_rate", bi_tbf_rate, 0, dtype_number, 4, 0, 0|0, dtype_string, dtype_number, dtype_number, dtype_number);
#line 99 "other.bi"
va_builtin_install_ex("debug_level", bi_debug_level, 0, dtype_number, 1, 1, 0|0, dtype_string);
#line 109 "other.bi"
va_builtin_install_ex("debug_spec", bi_debug_spec, 0, dtype_string, 2, 2, 0|0, dtype_string, dtype_number);
#line 128 "other.bi"
va_builtin_install_ex("debug", bi_debug, 0, dtype_unspecified, 1, 0, 0|0, dtype_string);
#line 134 "other.bi"
va_builtin_install_ex("program_trace", bi_program_trace, 0, dtype_unspecified, 1, 0, 0|0, dtype_string);
#line 140 "other.bi"
va_builtin_install_ex("cancel_program_trace", bi_cancel_program_trace, 0, dtype_unspecified, 1, 0, 0|0, dtype_string);
#line 146 "other.bi"
va_builtin_install_ex("stack_trace", bi_stack_trace, 0, dtype_unspecified, 0, 0, 0|0, dtype_unspecified);

#line 152 "other.bi"
	
#line 152
}
#line 152

#line 627 "../../mfd/builtin/snarf.m4"

#line 627

